searchNodes=[{"doc":"An Elixir library for transporting HL7 messages via MLLP (Minimal Lower Layer Protocol)","ref":"MLLP.html","title":"MLLP","type":"module"},{"doc":"Handles all Ack message operations including getting ack messages for a given HL7 message, creating the ack for a given message, and handling the return value for different ack codes.","ref":"MLLP.Ack.html","title":"MLLP.Ack","type":"module"},{"doc":"Gets the ack message for a given message and its application status","ref":"MLLP.Ack.html#get_ack_for_message/3","title":"MLLP.Ack.get_ack_for_message/3","type":"function"},{"doc":"Verifies the ack code in the ack message against the original HL7 message. Possible valid codes and their values include: AA -- Application Accept CA -- Application Accept AR -- Application Reject CR -- Application Reject AE -- Application Error CE -- Application Error All other possible codes would be considered bad ack codes and the method returns :error","ref":"MLLP.Ack.html#verify_ack_against_message/2","title":"MLLP.Ack.verify_ack_against_message/2","type":"function"},{"doc":"","ref":"MLLP.Ack.html#t:ack_verification_result/0","title":"MLLP.Ack.ack_verification_result/0","type":"type"},{"doc":"","ref":"MLLP.Ack.html#t:dispatcher_result/0","title":"MLLP.Ack.dispatcher_result/0","type":"type"},{"doc":"","ref":"MLLP.Ack.html#t:t/0","title":"MLLP.Ack.t/0","type":"type"},{"doc":"MLLP.Client provides a simple tcp client for sending and receiving data via MLLP over TCP. While MLLP is primarily used to send HL7 messages, MLLP.Client can be used to send non-hl7 messages, such as XML. Connection Behaviour Upon successful start up via start_link/4 , the client will attempt to establish a connection to the given address on the provided port. If a connection can not be immediately established, the client will keep trying to establish a connection per the value of :auto_reconnect_interval which defaults to 1 second. Therefor it is possible that before a connection is fully established, the caller may attempt to send a message which will result in MLLP.Client.Error.t() being returned containing the last error encountered in trying to establish a connection. Additionally, said behavour could be encountered at any point during life span of an MLLP.Client process if the connection becomees severed on either side. All connections, send, and receive failures will be logged as errors. Examples Sending messages as strings iex&gt; MLLP.Receiver . start ( dispatcher : MLLP.EchoDispatcher , port : 4090 ) { :ok , %{ pid : # PID &lt; 0 . 2167 . 0 &gt; , port : 4090 , receiver_id : # Reference &lt; 0.3312799297 . 2467299337.218126 &gt; } } iex&gt; { :ok , client } = MLLP.Client . start_link ( &quot;127.0.0.1&quot; , 4090 ) { :ok , # PID &lt; 0 . 369 . 0 &gt; } iex&gt; msg = &quot;MSH|^~ \\&amp; |MegaReg|XYZHospC|SuperOE|XYZImgCtr|20060529090131-0500|...&quot; &quot;MSH|^~ \\&amp; |MegaReg|XYZHospC|SuperOE|XYZImgCtr|20060529090131-0500|...&quot; iex&gt; MLLP.Client . send ( client , msg ) { :ok , &quot;MSH|^~ \\&amp; |SuperOE|XYZImgCtr|MegaReg|XYZHospC|20060529090131-0500||ACK^A01^ACK|...&quot; } iex&gt; Sending messages with HL7.Message.t() iex&gt; MLLP.Receiver . start ( dispatcher : MLLP.EchoDispatcher , port : 4090 ) { :ok , %{ pid : # PID &lt; 0 . 2167 . 0 &gt; , port : 4090 , receiver_id : # Reference &lt; 0.3312799297 . 2467299337.218126 &gt; } } iex&gt; { :ok , client } = MLLP.Client . start_link ( &quot;127.0.0.1&quot; , 4090 ) { :ok , # PID &lt; 0 . 369 . 0 &gt; } iex&gt; msg = HL7.Message . new ( HL7.Examples . wikipedia_sample_hl7 ( ) ) iex&gt; MLLP.Client . send ( client , msg ) { :ok , :application_accept , % MLLP.Ack { acknowledgement_code : &quot;AA&quot; , hl7_ack_message : nil , text_message : &quot;A real MLLP message dispatcher was not provided&quot; } } Using TLS iex&gt; tls_opts = [ cacertfile : &quot;/path/to/ca_certificate.pem&quot; , verify : :verify_peer , certfile : &quot;/path/to/server_certificate.pem&quot; , keyfile : &quot;/path/to/private_key.pem&quot; ] iex&gt; MLLP.Receiver . start ( dispatcher : MLLP.EchoDispatcher , port : 4090 , tls : tls_opts ) iex&gt; { :ok , client } = MLLP.Client . start_link ( &quot;localhost&quot; , 8154 , tls : [ verify : :verify_peer , cacertfile : &quot;path/to/ca_certfile.pem&quot; ] ) iex&gt; msg = HL7.Message . new ( HL7.Examples . wikipedia_sample_hl7 ( ) ) iex&gt; MLLP.Client . send ( client , msg ) { :ok , :application_accept , % MLLP.Ack { acknowledgement_code : &quot;AA&quot; , hl7_ack_message : nil , text_message : &quot;A real MLLP message dispatcher was not provided&quot; } }","ref":"MLLP.Client.html","title":"MLLP.Client","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MLLP.Client.html#child_spec/1","title":"MLLP.Client.child_spec/1","type":"function"},{"doc":"Returns true if the connection is open and established, otherwise false.","ref":"MLLP.Client.html#is_connected?/1","title":"MLLP.Client.is_connected?/1","type":"function"},{"doc":"Instructs the client to disconnect (if connected) and attempt a reconnect.","ref":"MLLP.Client.html#reconnect/1","title":"MLLP.Client.reconnect/1","type":"function"},{"doc":"Sends a message and receives a response. send/4 supports both HL7.Message and String.t(). All messages and responses will be wrapped and unwrapped via MLLP.Envelope.wrap_message/1 and MLLP.Envelope.unwrap_message/1 respectively In case the payload provided is an HL7.Message.t() the acknowledgment returned from the server will always be verified via MLLP.Ack.verify_ack_against_message/2 . This is the only case where an MLLP.Ack.ack_verification_result() will be returned. Options :reply_timeout - Optionally specify a timeout value for receiving a response. Must be a positive integer or :infinity . Defaults to 60 seconds.","ref":"MLLP.Client.html#send/4","title":"MLLP.Client.send/4","type":"function"},{"doc":"Sends a message without awaiting a response. Given the synchronous nature of MLLP/HL7 this function is mainly useful for testing purposes.","ref":"MLLP.Client.html#send_async/3","title":"MLLP.Client.send_async/3","type":"function"},{"doc":"Starts a new MLLP.Client. MLLP.Client.start_link/4 will start a new MLLP.Client process. This function will raise a ArgumentError if an invalid ip_address() is provided. Options :use_backoff - Specify if an exponential backoff should be used for connection. When an attempt to establish a connection fails, either post-init or at some point during the life span of the client, the backoff value will determine how often to retry a reconnection. Starts at 1 second and increases exponentially until reaching backoff_max_seconds seconds. Defaults to true . :backoff_max_seconds - Specify the max limit of seconds the backoff reconection attempt should take, defauls to 180 (3 mins). :auto_reconnect_interval - Specify the interval between connection attempts. Specifically, if an attempt to establish a connection fails, either post-init or at some point during the life span of the client, the value of this option shall determine how often to retry a reconnection. Defaults to 1000 milliseconds. This option will only be used if use_backoff is set to false . :reply_timeout - Optionally specify a timeout value for receiving a response. Must be a positive integer or :infinity . Defaults to 60 seconds. :socket_opts - A list of socket options as supported by :gen_tcp . Note that :binary , :packet , and :active can not be overridden. Default options are enumerated below. send_timeout: Defaults to 60 seconds :close_on_recv_error - A boolean value which dictates whether the client socket will be closed when an error in receiving a reply is encountered, this includes timeouts. Setting this to true is usually the safest behaviour to avoid a &quot;dead lock&quot; situation between a client and a server. This functions similarly to the :send_timeout option provided by :gen_tcp . Defaults to true . :tls - A list of tls options as supported by :ssl . When using TLS it is highly recommended you set :verify to :verify_peer , select a CA trust store using the :cacertfile or :cacerts options. Additionally, further hardening can be achieved through other ssl options such as enabling certificate revocation via the :crl_check and :crl_cache options and customization of enabled protocols and cipher suites for your specific use-case. See :ssl for details.","ref":"MLLP.Client.html#start_link/3","title":"MLLP.Client.start_link/3","type":"function"},{"doc":"Stops an MLLP.Client given a MLLP.Client pid. This function will always return :ok per GenServer.stop/1 , thus you may give it a pid that references a client which is already stopped.","ref":"MLLP.Client.html#stop/1","title":"MLLP.Client.stop/1","type":"function"},{"doc":"","ref":"MLLP.Client.html#t:ip_address/0","title":"MLLP.Client.ip_address/0","type":"type"},{"doc":"","ref":"MLLP.Client.html#t:pid_ref/0","title":"MLLP.Client.pid_ref/0","type":"type"},{"doc":"","ref":"MLLP.Client.html#t:t/0","title":"MLLP.Client.t/0","type":"type"},{"doc":"MLLP.ClientContract provides the behavior implemented by MLLP.Client. It may be useful for testing in your own application with tools such as Mox","ref":"MLLP.ClientContract.html","title":"MLLP.ClientContract","type":"behaviour"},{"doc":"","ref":"MLLP.ClientContract.html#c:send/4","title":"MLLP.ClientContract.send/4","type":"callback"},{"doc":"","ref":"MLLP.ClientContract.html#c:send_async/3","title":"MLLP.ClientContract.send_async/3","type":"callback"},{"doc":"","ref":"MLLP.ClientContract.html#t:client_error/0","title":"MLLP.ClientContract.client_error/0","type":"type"},{"doc":"","ref":"MLLP.ClientContract.html#t:error_reason/0","title":"MLLP.ClientContract.error_reason/0","type":"type"},{"doc":"","ref":"MLLP.ClientContract.html#t:error_type/0","title":"MLLP.ClientContract.error_type/0","type":"type"},{"doc":"","ref":"MLLP.ClientContract.html#t:options/0","title":"MLLP.ClientContract.options/0","type":"type"},{"doc":"","ref":"MLLP.ClientContract.html#t:send_options/0","title":"MLLP.ClientContract.send_options/0","type":"type"},{"doc":"","ref":"MLLP.DefaultPacketFramer.html","title":"MLLP.DefaultPacketFramer","type":"module"},{"doc":"","ref":"MLLP.DefaultPacketFramer.html#handle_unframed/1","title":"MLLP.DefaultPacketFramer.handle_unframed/1","type":"function"},{"doc":"","ref":"MLLP.DefaultTelemetry.html","title":"MLLP.DefaultTelemetry","type":"module"},{"doc":"","ref":"MLLP.DefaultTelemetry.html#execute/3","title":"MLLP.DefaultTelemetry.execute/3","type":"function"},{"doc":"","ref":"MLLP.Dispatcher.html","title":"MLLP.Dispatcher","type":"behaviour"},{"doc":"","ref":"MLLP.Dispatcher.html#c:dispatch/3","title":"MLLP.Dispatcher.dispatch/3","type":"callback"},{"doc":"Echo dispatcher informs the user that a dispatch function was not set and returns an application_accept or application_reject depending on if the message is valid (String) or not. Useful for debugging and serves as an example for writing your own dispatcher.","ref":"MLLP.EchoDispatcher.html","title":"MLLP.EchoDispatcher","type":"module"},{"doc":"Callback implementation for MLLP.Dispatcher.dispatch/3 .","ref":"MLLP.EchoDispatcher.html#dispatch/3","title":"MLLP.EchoDispatcher.dispatch/3","type":"function"},{"doc":"Helper functions encoding and decoding MLLP-framed messages. Below is an example of an MLLP-framed HL7 payload. Note the &lt;SB&gt;, &lt;CR&gt;, and &lt;EB&gt; characters. &lt; SB &gt; MSH | ^ ~ \\\\ &amp; | MegaReg | XYZHospC | SuperOE | XYZImgCtr | 20060529090131 - 0500 || ADT ^ A01 ^ ADT_A01 | 01052901 | P | 2.5 &lt; CR &gt; EVN || 200605290901 ||| | 200605290900 &lt; CR &gt; PID ||| 56782445 ^^^ UAReg ^ PI || KLEINSAMPLE ^ BARRY ^ Q ^ JR || 19620910 | M ||| ||| ||| | 0105 I30001 ^^^ 99 DEF ^ AN &lt; CR &gt; PV1 || I | W ^ 389 ^ 1 ^ UABH ^^^ ^ 3 ||| | 12345 ^ MORGAN ^ REX ^ J ^^^ MD ^ 0010 ^ UAMC ^ L || 6 ||| || A0 &lt; CR &gt; OBX | 1 | NM | ^ Body Height || 1.80 | m ^ Meter ^ ISO + ||| || F &lt; CR &gt; OBX | 2 | NM | ^ Body Weight || 79 | kg ^ Kilogram ^ ISO + ||| || F &lt; CR &gt; AL1 | 1 || ^ ASPIRIN &lt; CR &gt; DG1 | 1 || 786.50 ^ CHEST PAIN , UNSPECIFIED ^ I9 ||| A &lt; CR &gt; &lt; EB &gt; &lt; CR &gt;","ref":"MLLP.Envelope.html","title":"MLLP.Envelope","type":"module"},{"doc":"The MLLP Carriage Return character. In documentation it is often represented as &lt;CR&gt; . The cr is a single-byte character with the ASCII value 0x0D. This character may appear as &quot;\\r&quot; in text editors. Examples iex&gt; MLLP.Envelope . eb &lt;&lt; 28 &gt;&gt;","ref":"MLLP.Envelope.html#cr/0","title":"MLLP.Envelope.cr/0","type":"function"},{"doc":"The MLLP End-Block character. In documentation it is often represented as &lt;EB&gt; . The eb is a single-byte character with the ASCII value 0x1C. This character is also know as &quot;FS (File Separator)&quot; and may appear as ^\\ in text editors. Examples iex&gt; MLLP.Envelope . eb &lt;&lt; 28 &gt;&gt;","ref":"MLLP.Envelope.html#eb/0","title":"MLLP.Envelope.eb/0","type":"function"},{"doc":"In MLLP, each message ends with eb and cr . The eb_cr is just a simple concatenation of eb and cr . Examples iex&gt; MLLP.Envelope . eb_cr &lt;&lt; 28 , 13 &gt;&gt;","ref":"MLLP.Envelope.html#eb_cr/0","title":"MLLP.Envelope.eb_cr/0","type":"function"},{"doc":"The MLLP Start-Block character. In documentation it is often represented as &lt;SB&gt; . The sb is a single-byte character with the ASCII value 0x0B. This character is also know as &quot;VT (Vertical Tab)&quot; and may appear as \\\\v or ^K in text editors. Examples iex&gt; MLLP.Envelope . sb &quot; &quot;","ref":"MLLP.Envelope.html#sb/0","title":"MLLP.Envelope.sb/0","type":"function"},{"doc":"Unwraps an MLLP encoded message Example: iex&gt; MLLP.Envelope.unwrap_message &lt;&lt;11, 104, 105, 28, 13&gt;&gt; &quot;hi&quot;","ref":"MLLP.Envelope.html#unwrap_message/1","title":"MLLP.Envelope.unwrap_message/1","type":"function"},{"doc":"Wraps a string message in the MLLP start-of-block and end-of-block characters Example: iex&gt; MLLP.Envelope.wrap_message &quot;hi&quot; &lt;&lt;11, 104, 105, 28, 13&gt;&gt;","ref":"MLLP.Envelope.html#wrap_message/1","title":"MLLP.Envelope.wrap_message/1","type":"function"},{"doc":"","ref":"MLLP.FramingContext.html","title":"MLLP.FramingContext","type":"module"},{"doc":"","ref":"MLLP.FramingContext.html#t:t/0","title":"MLLP.FramingContext.t/0","type":"type"},{"doc":"","ref":"MLLP.PacketFramer.html","title":"MLLP.PacketFramer","type":"behaviour"},{"doc":"","ref":"MLLP.PacketFramer.html#c:handle_packet/2","title":"MLLP.PacketFramer.handle_packet/2","type":"callback"},{"doc":"","ref":"MLLP.Peer.html","title":"MLLP.Peer","type":"module"},{"doc":"","ref":"MLLP.Peer.html#validate/2","title":"MLLP.Peer.validate/2","type":"function"},{"doc":"","ref":"MLLP.Peer.html#t:error_type/0","title":"MLLP.Peer.error_type/0","type":"type"},{"doc":"","ref":"MLLP.Peer.html#t:peer_name/0","title":"MLLP.Peer.peer_name/0","type":"type"},{"doc":"","ref":"MLLP.Peer.html#t:t/0","title":"MLLP.Peer.t/0","type":"type"},{"doc":"A simple MLLP server. Minimal Lower Layer Protocol (MLLP) is an application level protocol which merely defines header and trailer delimiters for HL7 messages utilized in the healthcare industry for data interchange. Options The following options are required for starting an MLLP receiver either via start/1 or indirectly via child_spec/1 : :port - The tcp port the receiver will listen on. :dispatcher - Callback module messages ingested by the receiver will be passed to. This library ships with an echo only example dispatch module, MLLP.EchoDispatcher for example purposes, which can be provided as a value for this parameter. Optional parameters: :packet_framer - Callback module for received packets. Defaults to MLLP.DefaultPacketFramer :transport_opts - A map of parameters given to ranch as transport options. See Ranch Documentation for all transport options that can be provided. The default transport_opts are %{num_acceptors: 100, max_connections: 20_000} if none are provided. :context - A map which will be kept in receiver. This state is also honored by MLLP.FramingContext and made available to MLLP.Dispatcher implementations as :receiver_context on MLLP.FramingContext.t() .","ref":"MLLP.Receiver.html","title":"MLLP.Receiver","type":"module"},{"doc":"A function which can be used to embed an MLLP.Receiver under Elixir v1.5+ supervisors. Unlike start/1 , start/2 , or start/3 this function takes two additional options : ref and transport_opts . Note that if a ref option is not supplied a reference will be created for you using make_ref/0 . children = [ { MLLP.Receiver , [ ref : MyRef , port : 4090 , dispatcher : MLLP.EchoDispatcher , packet_framer : MLLP.DefaultPacketFramer , transport_opts : %{ num_acceptors : 25 , max_connections : 20_000 } ] } ] Supervisor . init ( children , strategy : :one_for_one ) See Options for details on required and optiomal parameters. Examples iex(1)&gt; opts = [ ref : MyRef , port : 4090 , dispatcher : MLLP.EchoDispatcher , packet_framer : MLLP.DefaultPacketFramer ] [ ref : MyRef , port : 4090 , dispatcher : MLLP.EchoDispatcher , packet_framer : MLLP.DefaultPacketFramer ] iex(2)&gt; MLLP.Receiver . child_spec ( opts ) %{ id : { :ranch_listener_sup , MyRef } , start : { :ranch_listener_sup , :start_link , [ MyRef , :ranch_tcp , %{ socket_opts : [ port : 4090 ] , num_acceptors : 100 , max_connections : 20_000 } , MLLP.Receiver , %{ packet_framer_module : MLLP.DefaultPacketFramer , dispatcher_module : MLLP.EchoDispatcher , context : %{ } , allowed_clients : %{ } , verify : nil } ] } , type : :supervisor , modules : [ :ranch_listener_sup ] , restart : :permanent , shutdown : :infinity }","ref":"MLLP.Receiver.html#child_spec/1","title":"MLLP.Receiver.child_spec/1","type":"function"},{"doc":"","ref":"MLLP.Receiver.html#normalize_ip/1","title":"MLLP.Receiver.normalize_ip/1","type":"function"},{"doc":"Starts an MLLP.Receiver. { :ok , info_map } = MLLP.Receiver . start ( port : 4090 , dispatcher : MLLP.EchoDispatcher ) If successful it will return a map containing the pid of the listener, the port it's listening on, and the receiver_id (ref) created, otherwise an error tuple. Note that this function is in constrast with child_spec/1 which can be used to embed MLLP.Receiver in your application or within a supervision tree as part of your application. This function is useful for starting an MLLP.Receiver from within a GenServer or for development and testing purposes. See Options for details on required and optiomal parameters.","ref":"MLLP.Receiver.html#start/1","title":"MLLP.Receiver.start/1","type":"function"},{"doc":"","ref":"MLLP.Receiver.html#stop/1","title":"MLLP.Receiver.stop/1","type":"function"},{"doc":"","ref":"MLLP.Receiver.html#t:dispatcher/0","title":"MLLP.Receiver.dispatcher/0","type":"type"},{"doc":"","ref":"MLLP.Receiver.html#t:options/0","title":"MLLP.Receiver.options/0","type":"type"},{"doc":"","ref":"MLLP.Receiver.html#t:t/0","title":"MLLP.Receiver.t/0","type":"type"},{"doc":"","ref":"MLLP.TCP.html","title":"MLLP.TCP","type":"module"},{"doc":"Callback implementation for MLLP.TCPContract.close/1 .","ref":"MLLP.TCP.html#close/1","title":"MLLP.TCP.close/1","type":"function"},{"doc":"Callback implementation for MLLP.TCPContract.connect/4 .","ref":"MLLP.TCP.html#connect/4","title":"MLLP.TCP.connect/4","type":"function"},{"doc":"Callback implementation for MLLP.TCPContract.recv/2 .","ref":"MLLP.TCP.html#recv/2","title":"MLLP.TCP.recv/2","type":"function"},{"doc":"Callback implementation for MLLP.TCPContract.recv/3 .","ref":"MLLP.TCP.html#recv/3","title":"MLLP.TCP.recv/3","type":"function"},{"doc":"Callback implementation for MLLP.TCPContract.send/2 .","ref":"MLLP.TCP.html#send/2","title":"MLLP.TCP.send/2","type":"function"},{"doc":"","ref":"MLLP.TCPContract.html","title":"MLLP.TCPContract","type":"behaviour"},{"doc":"","ref":"MLLP.TCPContract.html#c:close/1","title":"MLLP.TCPContract.close/1","type":"callback"},{"doc":"","ref":"MLLP.TCPContract.html#c:connect/4","title":"MLLP.TCPContract.connect/4","type":"callback"},{"doc":"","ref":"MLLP.TCPContract.html#c:recv/2","title":"MLLP.TCPContract.recv/2","type":"callback"},{"doc":"","ref":"MLLP.TCPContract.html#c:recv/3","title":"MLLP.TCPContract.recv/3","type":"callback"},{"doc":"","ref":"MLLP.TCPContract.html#c:send/2","title":"MLLP.TCPContract.send/2","type":"callback"},{"doc":"","ref":"MLLP.TLS.html","title":"MLLP.TLS","type":"module"},{"doc":"Callback implementation for MLLP.TLSContract.close/1 .","ref":"MLLP.TLS.html#close/1","title":"MLLP.TLS.close/1","type":"function"},{"doc":"Callback implementation for MLLP.TLSContract.connect/4 .","ref":"MLLP.TLS.html#connect/4","title":"MLLP.TLS.connect/4","type":"function"},{"doc":"Callback implementation for MLLP.TLSContract.recv/2 .","ref":"MLLP.TLS.html#recv/2","title":"MLLP.TLS.recv/2","type":"function"},{"doc":"Callback implementation for MLLP.TLSContract.recv/3 .","ref":"MLLP.TLS.html#recv/3","title":"MLLP.TLS.recv/3","type":"function"},{"doc":"Callback implementation for MLLP.TLSContract.send/2 .","ref":"MLLP.TLS.html#send/2","title":"MLLP.TLS.send/2","type":"function"},{"doc":"","ref":"MLLP.TLSContract.html","title":"MLLP.TLSContract","type":"behaviour"},{"doc":"","ref":"MLLP.TLSContract.html#c:close/1","title":"MLLP.TLSContract.close/1","type":"callback"},{"doc":"","ref":"MLLP.TLSContract.html#c:connect/4","title":"MLLP.TLSContract.connect/4","type":"callback"},{"doc":"","ref":"MLLP.TLSContract.html#c:recv/2","title":"MLLP.TLSContract.recv/2","type":"callback"},{"doc":"","ref":"MLLP.TLSContract.html#c:recv/3","title":"MLLP.TLSContract.recv/3","type":"callback"},{"doc":"","ref":"MLLP.TLSContract.html#c:send/2","title":"MLLP.TLSContract.send/2","type":"callback"},{"doc":"","ref":"MLLP.Client.Error.html","title":"MLLP.Client.Error","type":"exception"},{"doc":"","ref":"MLLP.Client.Error.html#t:t/0","title":"MLLP.Client.Error.t/0","type":"type"},{"doc":"mllp An Elixir library for transporting HL7 messages via MLLP (Minimal Lower Layer Protocol)","ref":"readme.html","title":"mllp","type":"extras"},{"doc":"This project is not at v1.0 yet. The API and internals will likely change quite a bit between now and v1.0. Also, be aware of the details of the license (Apache 2.0).","ref":"readme.html#status","title":"mllp - Status","type":"extras"},{"doc":"HL7 over MLLP First, let's start an MLLP.Receiver on port 4090. { :ok , r4090 } = MLLP.Receiver . start ( port : 4090 , dispatcher : MLLP.EchoDispatcher ) Next, start an MLLP.Client process and store its PID. { :ok , s1 } = MLLP.Client . start_link ( { 127 , 0 , 0 , 1 } , 4090 ) Alternatively, you could start a Client using a DNS name rather than an IP address. { :ok , s1 } = MLLP.Client . start_link ( &quot;localhost&quot; , 4090 ) Now send an HL7 message. MLLP.Client . send ( s1 , HL7.Examples . wikipedia_sample_hl7 ( ) |&gt; HL7.Message . new ( ) ) You will see log info like... 15 : 56 : 07.217 [ debug ] Receiver received data : [ &lt;&lt; 11 , 77 , 83 , 72 , 124 , 94 , 126 , 92 , 38 , 124 , 77 , 101 , 103 , 97 , 82 , 101 , 103 , 124 , 88 , 89 , 90 , 72 , 111 , 115 , 112 , 67 , 124 , 83 , 117 , 112 , 101 , 114 , 79 , 69 , 124 , 88 , 89 , 90 , 73 , 109 , 103 , 67 , 116 , 114 , 124 , 50 , 48 , 48 , 54 , 48 , ... &gt;&gt; ] . 15 : 56 : 07.217 [ info ] The EchoDispatcher simply logs and discards messages . Message type : mllp_hl7 Message : MSH | ^ ~ \\ &amp; | MegaReg | XYZHospC | SuperOE | XYZImgCtr | 20060529090131 - 0500 || ADT ^ A01 ^ ADT_A01 | 01052901 | P | DG1 | 1 || 786.50 ^ CHEST PAIN , UNSPECIFIED ^ I9 ||| A ||| FFMD ^ 0010 ^ UAMC ^ L || 67890 ^ GRAINGER ^ LUCY ^ X ^^^ MD ^ 0010 ^ UAMC ^ L | MED ||| || A0 || 13579 ^ POTTER ^ SHERMAN ^ T ^^^ MD ^ 0010 ^ UAMC ^ L ||| ||| ||| ||| ||| ||| ||| ||| ||| 2006052909000 ^ ^ O ||| ||| | 0105 I30001 ^^^ 99 DEF ^ AN 15 : 56 : 07.218 [ debug ] MLLP Envelope performed unnecessary unwrapping of unwrapped message { :error , :application_reject , % MLLP.Ack { acknowledgement_code : &quot;AR&quot; , hl7_ack_message : nil , text_message : &quot;A real MLLP message dispatcher was not provided&quot; } } The Logger [debug] part tells us that the Receiver received the HL7 message. The Logger [info] part explains that the EchoDispatcher does not route the message anywhere (just &quot;logs and discards&quot; messages). Finally, the return value ( {:error, :application_reject, ...} ) is a NACK. The EchoDispatcher will not reply with an :application_accept . Now, we will stop the Receiver. MLLP.Receiver . stop ( 4090 ) Writing a message dispatcher MLLP does not ship with a default message dispatcher as the cases can vary significantly from domain to domain. Instead, MLLP provides you with helper libraries (e.g., HL7 and helper functions so you can easily craft your own message dispatcher to suit your needs. Now we will set up a receiver with a custom dispatcher. defmodule DemoDispatcher do @behaviour MLLP.Dispatcher def dispatch ( :mllp_hl7 , message , state ) when is_binary ( message ) do # Put your message handling logic here reply = MLLP.Ack . get_ack_for_message ( message , :application_accept ) |&gt; to_string ( ) |&gt; MLLP.Envelope . wrap_message ( ) { :ok , %{ state | reply_buffer : reply } } end end Now we can configure a Receiver to use our newly defined DemoDispatcher. { :ok , r4090 } = MLLP.Receiver . start ( port : 4090 , dispatcher : DemoDispatcher ) Next, let's set up a Client to exercise our new Receiver. { :ok , s2 } = MLLP.Client . start_link ( { 127 , 0 , 0 , 1 } , 4090 ) Now when you send a message to the Receiver's port, the custom DemoDispatcher will be used. MLLP.Client . send ( s2 , HL7.Examples . wikipedia_sample_hl7 ( ) |&gt; HL7.Message . new ( ) ) Notice the DemoDispatcher warning is no longer in the Logger output. 15 : 43 : 26.605 [ debug ] MLLP Envelope performed unnecessary unwrapping of unwrapped message 15 : 43 : 26.606 [ debug ] Receiver received data : [ &lt;&lt; 11 , 77 , 83 , 72 , 124 , 94 , 126 , 92 , 38 , 124 , 77 , 101 , 103 , 97 , 82 , 101 , 103 , 124 , 88 , 89 , 90 , 72 , 111 , 115 , 112 , 67 , 124 , 83 , 117 , 112 , 101 , 114 , 79 , 69 , 124 , 88 , 89 , 90 , 73 , 109 , 103 , 67 , 116 , 114 , 124 , 50 , 48 , 48 , 54 , 48 , ... &gt;&gt; ] . { :ok , :application_accept , % MLLP.Ack { acknowledgement_code : &quot;AA&quot; , hl7_ack_message : nil , text_message : &quot;&quot; } } Non-HL7 over MLLP While the MLLP framing protocol is mostly for HL7, some companies also send and receive non-HL7 data over MLLP. If you find yourself needing to integrate with a system that has made this choice the following will be helpful. defmodule ExpandedDemoDispatcher do @behaviour MLLP.Dispatcher def dispatch ( :mllp_hl7 , message , state ) when is_binary ( message ) do # Your message handling logic here reply = MLLP.Ack . get_ack_for_message ( message , :application_accept ) |&gt; to_string ( ) |&gt; MLLP.Envelope . wrap_message ( ) { :ok , %{ state | reply_buffer : reply } } end def dispatch ( :mllp_unknown , message , state ) when is_binary ( message ) do # Your message handling logic here reply = &quot;Got the BLOB&quot; { :ok , %{ state | reply_buffer : reply } } end end Now, to use this expanded custom dispatcher with a Client and Receiver. Let's start by getting a new Receiver. iex&gt; { :ok , r4091 } = MLLP.Receiver . start ( port : 4091 , dispatcher : ExpandedDemoDispatcher ) { :ok , %{ pid : # PID &lt; 0 . 367 . 0 &gt; , port : 4091 , receiver_id : # Reference &lt; 0.144001725 . 3813670918.119240 &gt; } } Next, start a Client. iex&gt; { :ok , s3 } = MLLP.Client . start_link ( &quot;localhost&quot; , 4091 ) { :ok , # PID &lt; 0 . 383 . 0 &gt; } Now let's send and receive non-HL7 data over MLLP iex&gt; MLLP.Client . send ( s3 , &quot;Hip hip hurray&quot; ) 15 : 14 : 20.531 [ debug ] Receiver received data : [ &lt;&lt; 11 , 72 , 105 , 112 , 32 , 104 , 105 , 112 , 32 , 104 , 117 , 114 , 114 , 97 , 121 , 28 , 13 &gt;&gt; ] . { :ok , &quot;Got the BLOB&quot; }","ref":"readme.html#usage","title":"mllp - Usage","type":"extras"},{"doc":"Can be namespaced or changed by passing a replacement for DefaultTelemetry. The default emits [:mllp, :client, :status | :sending | :received] telemetry events. Emitted measurements contain status, errors, timestamps, etc. The emitted metadata contains the Client state.","ref":"readme.html#telemetry-client-only-currently","title":"mllp - Telemetry (Client only currently)","type":"extras"},{"doc":"Support for TLS can be added for MLLP protocol to secure the data transfer between a client and receiver. Follow steps below to start a receiver and client using TLS Create certificates The first step in TLS configuration is to create a TLS certificates, which can be used by the server to start the listener. To help you with creating self signed certificate, run following script: sh tls/tls.sh This script creates the following certs: root ca server certificate signed by root ca client certificate signed by root ca expired client certificate signed by root ca Start Receiver iex&gt; MLLP.Receiver . start ( port : 8154 , dispatcher : MLLP.EchoDispatcher , transport_opts : %{ tls : [ cacertfile : &quot;tls/root-ca/ca_certificate.pem&quot; , verify : :verify_none , certfile : &quot;tls/server/server_certificate.pem&quot; , keyfile : &quot;tls/server/private_key.pem&quot; ] } ) Start Client iex&gt; { :ok , s3 } = MLLP.Client . start_link ( &quot;localhost&quot; , 8154 , tls : [ verify : :verify_peer , cacertfile : &quot;tls/root-ca/ca_certificate.pem&quot; ] ) Send a message iex&gt; MLLP.Client . send ( s3 , HL7.Examples . wikipedia_sample_hl7 ( ) |&gt; HL7.Message . new ( ) )","ref":"readme.html#using-tls","title":"mllp - Using TLS","type":"extras"},{"doc":"MLLP listener can enforce client to provide a valid certificate before establishing a successful connection. Follow steps below to use client cert with a listener Start MLLP listener with :verify_peer option iex&gt; MLLP.Receiver . start ( port : 8154 , dispatcher : MLLP.EchoDispatcher , transport_opts : %{ tls : [ cacertfile : &quot;tls/root-ca/ca_certificate.pem&quot; , verify : :verify_peer , certfile : &quot;tls/server/server_certificate.pem&quot; , keyfile : &quot;tls/server/private_key.pem&quot; ] } ) Start MLLP Client with client cert iex&gt; { :ok , s3 } = MLLP.Client . start_link ( &quot;localhost&quot; , 8154 , tls : [ verify : :verify_peer , cacertfile : &quot;tls/root-ca/ca_certificate.pem&quot; , certfile : &quot;tls/client/client_certificate.pem&quot; , keyfile : &quot;tls/client/private_key.pem&quot; ] ) Send a message iex&gt; MLLP.Client . send ( s3 , HL7.Examples . wikipedia_sample_hl7 ( ) |&gt; HL7.Message . new ( ) )","ref":"readme.html#using-client-certificates","title":"mllp - Using Client Certificates","type":"extras"},{"doc":"MLLP listener supports two options to restrict incoming client connections to make sure it accepts only trusted clients. IP/DNS restriction - In this mode, we can restrict incoming connections using Client IP/DNS. Client Cert Check - If verify: :verify_peer option is enabled on listener, it will enforce client to send a valid client cert and will only allow the connection if certificate returned from the client is valid and trusted. Here are couple of exmaples of using client restrictions Options 1 - Client IP/DNS restrictions Start MLLP listener with allowed_clients options iex&gt; MLLP.Receiver . start ( port : 8154 , dispatcher : MLLP.EchoDispatcher , allowed_clients : [ &quot;localhost&quot; ] ) Start MLLP Client iex&gt; { :ok , s3 } = MLLP.Client . start_link ( &quot;localhost&quot; , 8154 ) Send a message iex&gt; MLLP.Client . send ( s3 , HL7.Examples . wikipedia_sample_hl7 ( ) |&gt; HL7.Message . new ( ) ) In this example starting a client on another server other than localhost will fail and a warning will be logged on the server [warn] Failed to verify client {ip, port}, error: :client_ip_not_allowed This example provided is without TLS, We can modify it to use with TLS. Make sure to specify verify: :verify_none option in transport_opts on the listener. See Using TLS : for details on setting up TLS connections. Options 2 - Client Cert Check Start MLLP listener with TLS and allowed_clients options iex&gt; MLLP.Receiver . start ( port : 8154 , dispatcher : MLLP.EchoDispatcher , allowed_clients : [ &quot;client-1&quot; ] , transport_opts : %{ tls : [ cacertfile : &quot;tls/root-ca/ca_certificate.pem&quot; , verify : :verify_peer , certfile : &quot;tls/server/server_certificate.pem&quot; , keyfile : &quot;tls/server/private_key.pem&quot; ] } ) Start MLLP Client iex&gt; { :ok , s3 } = MLLP.Client . start_link ( &quot;localhost&quot; , 8154 , tls : [ verify : :verify_peer , cacertfile : &quot;tls/root-ca/ca_certificate.pem&quot; , certfile : &quot;tls/client/client_certificate.pem&quot; , keyfile : &quot;tls/client/private_key.pem&quot; ] ) Send a message iex&gt; MLLP.Client . send ( s3 , HL7.Examples . wikipedia_sample_hl7 ( ) |&gt; HL7.Message . new ( ) ) In the above scenarios we start a client with a valid certificate, but the cert issued is not one of the trusted client by the listener, thus the connection fails and a warning is logged by the listener [warn] Failed to verify client {ip, port}, error: :fail_to_verify_client_cert","ref":"readme.html#using-client-restrictions","title":"mllp - Using Client Restrictions","type":"extras"},{"doc":"Elixir-MLLP source code is released under Apache 2 License. Check LICENSE file for more information.","ref":"readme.html#license","title":"mllp - License","type":"extras"}]